unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Process;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

  TDownLoadThread = class(TThread)
  private
  protected
    procedure Execute; override;
  public
    Constructor Create(CreateSuspended : boolean);
  end;

var
  Form1: TForm1;
  DownLoadThread: TDownLoadThread;
  JavaProcess: TProcess;

implementation

{$R *.lfm}

{ TForm1 }

constructor TDownLoadThread.Create(CreateSuspended : boolean);  //Öffnen der Datenbank
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;

procedure TDownloadThread.Execute;
var
  n, i: integer;
  bla: TStringList;
  MemStrm: TMemoryStream;

const
  BytesRead: Integer = 0;
  READ_BYTES = 2048;

begin
  bla := TStringList.Create;
  MemStrm := TMemoryStream.Create;

  while javaProcess.Running do
  begin

  // stellt sicher, dass wir Platz haben
    MemStrm.SetSize(BytesRead + READ_BYTES);

    // versuche, es zu lesen
    n := javaProcess.Output.Read((MemStrm.Memory + BytesRead)^, READ_BYTES);
    if n > 0 then Inc(BytesRead, n);

    // lese den letzten Teil
    repeat
      // stellt sicher, dass wir Platz haben
      MemStrm.SetSize(BytesRead + READ_BYTES);
      // versuche es zu lesen
      if javaProcess.Output.NumBytesAvailable>0 then
        n := javaProcess.Output.Read((MemStrm.Memory + BytesRead)^, READ_BYTES)
      else
        n:=0;

      if n > 0 then
        Inc(BytesRead, n);

      until n <= 0;

    MemStrm.SetSize(BytesRead);

    //Ausgabe
    bla.LoadFromStream(MemStrm);
    for i := 0 to bla.Count - 1 do
      Form1.Memo1.Lines.add(bla[i]);

  end;

  bla.Free;
  MemStrm.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  javaProcess := TProcess.Create(nil);

  try

//    javaProcess.Executable := 'KonsoleTest.exe'; //auszuführendes Programm
//    javaProcess.Executable := 'cmd /C "C:\Program Files (x86)\Java\jre7\bin\java.exe" -jar Hello.jar';
    javaProcess.Executable := 'cmd';                                               //cmd starten
    javaProcess.Parameters.Add('/C');                                              //es soll nachfolgender Code ausgeführt werden
    javaProcess.Parameters.Add('"C:\Program Files (x86)\Java\jre7\bin\java.exe"');
    javaProcess.Parameters.Add('-jar');
    javaProcess.Parameters.Add('Hello.jar');                                       //Hello.jar liegt im Projektverzeichnis
    javaProcess.Options := [poUsePipes];
    javaProcess.ShowWindow := swoHide; //Fenster der Konsole nicht anzeigen
    javaProcess.Execute;
  finally
    DownloadThread := TDownloadThread.Create(True);
  end;
  DownloadThread.Start;
end;

end.

